wmbutton
-------------------------------------------------------------
   Code is based on wmppp, wmload, wmtime, wmcp, and asbutton
   Author: Edward H. Flora <ehf_dockapps@cox.net>
	   This version is released by:
	   Window Maker Team <wmaker-dev@lists.windowmaker.org>

DESCRIPTION:
------------
wmbutton is a simple application launching program that sits in the
dock in WindowMaker, can be swallowed by Wharf in Afterstep, and
should be fairly configurable.

LICENSING:
----------
This program is released under the GPL license.  A copy (in case you
don't already have hundreds of them floating around) can be found in
this distribution in the file COPYING

CONTRIBUTORS:
-------------
              Christian 'Greek0' Aichinger <Greek0@gmx.net>
                  Did some code cleanup and fixed several memory leaks.
              Ralf Horstmann <ralf.horstmann@gmx.de>
                  Added ability to load pixmaps at startup,
                  without having to re-compile
              Michael Cohrs <camico@users.sourceforge.net>
                  Added Tool Tips, and updated graphics
              Bruno Essmann <essmann@users.sourceforge.net>)
                  Creator of wmpager
              Ben Cohen <buddog@aztec.asu.edu>
                  original author of wmcp (et al.)
              Thomas Nemeth <tnemeth@multimania.com>
                  contributor to wmcp
              Casey Harkins <charkins@cs.wisc.edu>
                  Bug fix reading config file path - 3/6/99
                  Added button-presses, and other - denoted by *charkins*
              Michael Henderson <mghenderson@lanl.gov>
                  Application ideas, suggestions
              Ryan ?? <pancake@mindspring.com>
                  Modified wmbutton to asbutton.
                  Note: asbutton is a seperate program, not associated
                        with wmbutton (just as wmbutton is not associated
                        with wmcp)
              Jon Bruno
                  Web Page Development
The contributors listed above are not necessarily involved with the
development of wmbutton.  I'm listing them here partially as thanks for
helping out, catching bugs in the code, etc.

INSTALLATION:
-------------
	Untar the file:
		tar xvzf wmbutton-*.tar.gz

	CD to source directory:
		cd wmbutton-*

	Edit background xpm, and buttons.xpm to your preferences
	There are icon files in ./icons to work from

	Compile it:
	 	make clean; make

	Copy the config file:
		cp .wmbutton ~

	Put the executable somewhere in your path:
		mv wmbutton /usr/local/bin (or anyhere in your path)

	Run it:
		wmbutton &

	Grab the appicon and move it to the dock.
	Change the settings to start with Windowmaker

	Afterstep Wharf 1.6.??:
	*Wharf wmbutton -Swallow "wmbutton" wmbutton &

    ***Note***:
	The appicon has only a two pixel border where you can grab
	and move it.

	If make doesn't work, you may need to fiddle with the settings in
	the Makefile.

	Tested on: (Well, it runs, I don't know if 'Tested' is quite right...)
		WindowMaker-0.80.1
		Afterstep 1.6.?
		Fluxbox 0.9.9
		Clients: Red Hat 8.x, Kernel 2.4.18


USAGE:
------
wmbutton [-g geom] [-d dpy] [-f cfgfile] [-b btnfile] [-F <font>]
	 [-v] [-s] [-n]

-g <geometry>  Window Geometry - ie: 64x64+10+10
-d <display>   Display -  ie: 127.0.0.1:0.0
-f <filename>  Full path to configuration file.
-b <filename>  Full path to button xpm.
-F <font>      Custom tooltip font (e.g. -b\&h-lucidatypewriter-medium-*-*-*-12-*)
-v             Verbose Mode.
-h             Help. This message.
-m             Disable Middle Mouse functionality.
-s             Swap tooltip colors.
-n             Turn off tooltips.

Left mouse button:
	Selects the application to launch, numbered 1 through 9

Middle mouse button: (unless disabled (-m))
	Selects the application to launch, numbered 11 through 19

Right mouse button:
	Selects the application to launch, numbered 21 through 29

NOTES:
------
This is a simple application launching tool for use in WindowMaker, and
possibly Afterstep.  (Who knows, it should run for other window managers too,
by why bother??  It is taken from wmcp, by Ben Cohen, and modified just
enough to run applications rather than send ALT-[1..9] key sequences to
WindowMaker.  It has also taken some ideas from asbuttons, and
included them back into the original.  There may still be some code
left over from wmcp that is no longer needed, but...

The mini-icons must be combined into a single graphic, buttons.xpm.  The
background border is defined in backdrop.xpm.  Both must be edited in your
favorite graphics editor (GIMP??), and then recompiled.  wmbuttons uses a
configuration file (usually ~/.wmbutton) for which applications to launch.
There is no need to restart wmbuttons when simply changing the configuration,
as wmbutton searches the file whenever a button is pressed.

As of release 0.5, you can also pass in your own pixmap file for the
buttons, to override the buttons that are compiled it.  This file should
still have the same height and width so that it will make sense,
though really you give it any XPM you want, but it will only display
the upper left 54x54 pixel corner.


An example file is included, related to the the buttons.xpm graphic file.

TODO:
-----
Add ability (via config file) to use discrete 16x16 pixel icons for
  the buttons, rather than having to paste them all into the existing file.
Make changing icons and/or background graphics easier.
Allow for less than 9 icons, 4 would be nicer on the mini-icon size.

BUGS:
-----
Remember, they're just undocumented FEATURES!!!

Probably Lots.  Send comments (preferably with fixes) to
<wmaker-dev@lists.windowmaker.org>


Good Luck.


"C code.  C code run.  Run, code, run.
			PLEASE!?!?!?!?!?!?"


